/** Returns a test model */

module.exports = function () {
    return {"reactions": [{"subsystem": "Pyruvate Metabolism", "name": "acetaldehyde dehydrogenase (acetylating)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"accoa_c": 1.0, "acald_c": -1.0, "coa_c": -1.0, "h_c": 1.0, "nad_c": -1.0, "nadh_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACALD", "gene_reaction_rule": "(b0351 or b1241)"}, {"subsystem": "Transport, Extracellular", "name": "acetaldehyde reversible transport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"acald_c": 1.0, "acald_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACALDt", "gene_reaction_rule": "s0001"}, {"subsystem": "Pyruvate Metabolism", "name": "acetate kinase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"ac_c": -1.0, "actp_c": 1.0, "adp_c": 1.0, "atp_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACKr", "gene_reaction_rule": "(b3115 or b2296 or b1849)"}, {"subsystem": "Citric Acid Cycle", "name": "aconitase (half-reaction A, Citrate hydro-lyase)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_c": 1.0, "acon_C_c": 1.0, "cit_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACONTa", "gene_reaction_rule": "(b0118 or b1276)"}, {"subsystem": "Citric Acid Cycle", "name": "aconitase (half-reaction B, Isocitrate hydro-lyase)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "icit_c": 1.0, "acon_C_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACONTb", "gene_reaction_rule": "(b0118 or b1276)"}, {"subsystem": "Transport, Extracellular", "name": "acetate reversible transport via proton symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"ac_c": 1.0, "h_e": -1.0, "ac_e": -1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ACt2r", "gene_reaction_rule": ""}, {"subsystem": "Oxidative Phosphorylation", "name": "adenylate kinase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"amp_c": -1.0, "atp_c": -1.0, "adp_c": 2.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ADK1", "gene_reaction_rule": "b0474"}, {"subsystem": "Citric Acid Cycle", "name": "2-Oxoglutarate dehydrogenase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"akg_c": -1.0, "nadh_c": 1.0, "succoa_c": 1.0, "coa_c": -1.0, "nad_c": -1.0, "co2_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "AKGDH", "gene_reaction_rule": "( b0116  and  b0726  and  b0727 )"}, {"subsystem": "Transport, Extracellular", "name": "2-oxoglutarate reversible transport via symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"akg_c": 1.0, "h_e": -1.0, "h_c": 1.0, "akg_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "AKGt2r", "gene_reaction_rule": "b2587"}, {"subsystem": "Pyruvate Metabolism", "name": "alcohol dehydrogenase (ethanol)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"acald_c": 1.0, "nadh_c": 1.0, "nad_c": -1.0, "etoh_c": -1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ALCD2x", "gene_reaction_rule": "(b0356 or b1478 or b1241)"}, {"subsystem": "Oxidative Phosphorylation", "name": "ATP maintenance requirement", "upper_bound": 1000.0, "lower_bound": 8.39, "notes": {}, "metabolites": {"h2o_c": -1.0, "pi_c": 1.0, "atp_c": -1.0, "adp_c": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ATPM", "gene_reaction_rule": ""}, {"subsystem": "Oxidative Phosphorylation", "name": "ATP synthase (four protons for one ATP)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_c": 1.0, "atp_c": 1.0, "h_e": -4.0, "h_c": 3.0, "adp_c": -1.0, "pi_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ATPS4r", "gene_reaction_rule": "(((b3736 and b3737 and b3738) and (b3731 and b3732 and b3733 and b3734 and b3735)) or ((b3736 and b3737 and b3738) and (b3731 and b3732 and b3733 and b3734 and b3735) and b3739))"}, {"subsystem": "", "name": "Biomass Objective Function with GAM", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -59.81, "adp_c": 59.81, "glu__L_c": -4.9414, "g3p_c": -0.129, "e4p_c": -0.361, "h_c": 59.81, "r5p_c": -0.8977, "atp_c": -59.81, "f6p_c": -0.0709, "pyr_c": -2.8328, "nad_c": -3.547, "coa_c": 3.7478, "oaa_c": -1.7867, "g6p_c": -0.205, "nadh_c": 3.547, "akg_c": 4.1182, "accoa_c": -3.7478, "3pg_c": -1.496, "pep_c": -0.5191, "gln__L_c": -0.2557, "nadp_c": 13.0279, "nadph_c": -13.0279, "pi_c": 59.81}, "objective_coefficient": 1.0, "variable_kind": "continuous", "id": "Biomass_Ecoli_core_w_GAM", "gene_reaction_rule": ""}, {"subsystem": "Transport, Extracellular", "name": "CO2 transporter via diffusion", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"co2_c": 1.0, "co2_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "CO2t", "gene_reaction_rule": "s0001"}, {"subsystem": "Citric Acid Cycle", "name": "citrate synthase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "accoa_c": -1.0, "cit_c": 1.0, "coa_c": 1.0, "h_c": 1.0, "oaa_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "CS", "gene_reaction_rule": "b0720"}, {"subsystem": "Oxidative Phosphorylation", "name": "cytochrome oxidase bd (ubiquinol-8: 2 protons)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"o2_c": -0.5, "h2o_c": 1.0, "q8h2_c": -1.0, "h_e": 2.0, "h_c": -2.0, "q8_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "CYTBD", "gene_reaction_rule": "((b0978 and b0979) or (b0733 and b0734))"}, {"subsystem": "Transport, Extracellular", "name": "D-lactate transport via proton symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"lac__D_e": -1.0, "h_e": -1.0, "lac__D_c": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "D_LACt2", "gene_reaction_rule": "( b2975  or  b3603 )"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "enolase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"pep_c": 1.0, "h2o_c": 1.0, "2pg_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ENO", "gene_reaction_rule": "b2779"}, {"subsystem": "Transport, Extracellular", "name": "ethanol reversible transport via proton symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"etoh_e": -1.0, "h_e": -1.0, "h_c": 1.0, "etoh_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ETOHt2r", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Acetate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"ac_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_ac_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Acetaldehyde exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"acald_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_acald_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "2-Oxoglutarate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"akg_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_akg_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "CO2 exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"co2_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_co2_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Ethanol exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"etoh_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_etoh_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Formate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"for_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_for_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "D-Fructose exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"fru_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_fru_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Fumarate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"fum_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_fum_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "D-Glucose exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"glc__D_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_glc_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "L-Glutamine exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"gln__L_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_gln__L_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "L-Glutamate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"glu__L_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_glu__L_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "H+ exchange", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_h_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "H2O exchange", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_h2o_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "D-Lactate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"lac__D_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_lac__D_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "L-Malate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"mal__L_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_mal__L_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Ammonium exchange", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"nh4_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_nh4_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "O2 exchange", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"o2_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_o2_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Phosphate exchange", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"pi_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_pi_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Pyruvate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"pyr_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_pyr_e", "gene_reaction_rule": ""}, {"subsystem": "Exchange", "name": "Succinate exchange", "upper_bound": 1000.0, "lower_bound": 0, "notes": {}, "metabolites": {"succ_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "EX_succ_e", "gene_reaction_rule": ""}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "fructose-bisphosphate aldolase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"dhap_c": 1.0, "fdp_c": -1.0, "g3p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FBA", "gene_reaction_rule": "(b2097 or b1773 or b2925)"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "fructose-bisphosphatase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "pi_c": 1.0, "fdp_c": -1.0, "f6p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FBP", "gene_reaction_rule": "(b3925 or b4232)"}, {"subsystem": "Transport, Extracellular", "name": "formate transport via proton symport (uptake only)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"for_e": -1.0, "h_e": -1.0, "h_c": 1.0, "for_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FORt2", "gene_reaction_rule": "(b0904 or b2492)"}, {"subsystem": "Transport, Extracellular", "name": "formate transport via diffusion", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"for_e": 1.0, "for_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FORti", "gene_reaction_rule": "(b0904 or b2492)"}, {"subsystem": "Oxidative Phosphorylation", "name": "fumarate reductase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"q8h2_c": -1.0, "succ_c": 1.0, "fum_c": -1.0, "q8_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FRD7", "gene_reaction_rule": "(b4151 and b4152 and b4153 and b4154)"}, {"subsystem": "Transport, Extracellular", "name": "Fructose transport via PEP:Pyr PTS (f6p generating)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pep_c": -1.0, "fru_e": -1.0, "pyr_c": 1.0, "f6p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FRUpts2", "gene_reaction_rule": "(b1817 and b1818 and b1819 and b2415 and b2416)"}, {"subsystem": "Citric Acid Cycle", "name": "fumarase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "fum_c": -1.0, "mal__L_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FUM", "gene_reaction_rule": "( b1612  or  b4122  or  b1611 )"}, {"subsystem": "Transport, Extracellular", "name": "Fumarate transport via proton symport (2 H)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"fum_c": 1.0, "h_e": -2.0, "fum_e": -1.0, "h_c": 2.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "FUMt2_2", "gene_reaction_rule": "b3528"}, {"subsystem": "Pentose Phosphate Pathway", "name": "glucose 6-phosphate dehydrogenase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"6pgl_c": 1.0, "g6p_c": -1.0, "nadp_c": -1.0, "nadph_c": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "G6PDH2r", "gene_reaction_rule": "b1852"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "glyceraldehyde-3-phosphate dehydrogenase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"nadh_c": 1.0, "nad_c": -1.0, "g3p_c": -1.0, "h_c": 1.0, "13dpg_c": 1.0, "pi_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GAPD", "gene_reaction_rule": "b1779"}, {"subsystem": "Transport, Extracellular", "name": "D-glucose transport via PEP:Pyr PTS", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pep_c": -1.0, "pyr_c": 1.0, "g6p_c": 1.0, "glc__D_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLCpts", "gene_reaction_rule": "((b2417 and b1101 and b2415 and b2416) or (b1817 and b1818 and b1819 and b2415 and b2416) or (b2417 and b1621 and b2415 and b2416))"}, {"subsystem": "Glutamate Metabolism", "name": "glutamine synthetase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"atp_c": -1.0, "glu__L_c": -1.0, "h_c": 1.0, "adp_c": 1.0, "pi_c": 1.0, "nh4_c": -1.0, "gln__L_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLNS", "gene_reaction_rule": "(b3870 or b1297)"}, {"subsystem": "Transport, Extracellular", "name": "L-glutamine transport via ABC system", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "atp_c": -1.0, "h_c": 1.0, "adp_c": 1.0, "gln__L_e": -1.0, "pi_c": 1.0, "gln__L_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLNabc", "gene_reaction_rule": "(b0811 and b0810 and b0809)"}, {"subsystem": "Glutamate Metabolism", "name": "glutamate dehydrogenase (NADP)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"akg_c": 1.0, "h2o_c": -1.0, "nadp_c": -1.0, "nadph_c": 1.0, "glu__L_c": -1.0, "h_c": 1.0, "nh4_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLUDy", "gene_reaction_rule": "b1761"}, {"subsystem": "Glutamate Metabolism", "name": "glutaminase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "glu__L_c": 1.0, "nh4_c": 1.0, "gln__L_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLUN", "gene_reaction_rule": "(b1812 or b0485 or b1524)"}, {"subsystem": "Glutamate Metabolism", "name": "glutamate synthase (NADPH)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"akg_c": -1.0, "nadp_c": 1.0, "nadph_c": -1.0, "glu__L_c": 2.0, "h_c": -1.0, "gln__L_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLUSy", "gene_reaction_rule": "(b3212 and b3213)"}, {"subsystem": "Transport, Extracellular", "name": "L-glutamate transport via proton symport, reversible (periplasm)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"glu__L_c": 1.0, "h_e": -1.0, "glu__L_e": -1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GLUt2r", "gene_reaction_rule": "b4077"}, {"subsystem": "Pentose Phosphate Pathway", "name": "phosphogluconate dehydrogenase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"6pgc_c": -1.0, "co2_c": 1.0, "nadph_c": 1.0, "nadp_c": -1.0, "ru5p__D_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "GND", "gene_reaction_rule": "b2029"}, {"subsystem": "Transport, Extracellular", "name": "H2O transport via diffusion", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"h2o_c": 1.0, "h2o_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "H2Ot", "gene_reaction_rule": "(b0875 or s0001)"}, {"subsystem": "Citric Acid Cycle", "name": "isocitrate dehydrogenase (NADP)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"akg_c": 1.0, "icit_c": -1.0, "co2_c": 1.0, "nadp_c": -1.0, "nadph_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ICDHyr", "gene_reaction_rule": "b1136"}, {"subsystem": "Anaplerotic reactions", "name": "Isocitrate lyase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"succ_c": 1.0, "icit_c": -1.0, "glx_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ICL", "gene_reaction_rule": "b4015"}, {"subsystem": "Pyruvate Metabolism", "name": "D lactate dehydrogenase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"pyr_c": 1.0, "nadh_c": 1.0, "lac__D_c": -1.0, "h_c": 1.0, "nad_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "LDH_D", "gene_reaction_rule": "(b2133 or b1380)"}, {"subsystem": "Anaplerotic reactions", "name": "malate synthase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "mal__L_c": 1.0, "glx_c": -1.0, "h_c": 1.0, "accoa_c": -1.0, "coa_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "MALS", "gene_reaction_rule": "( b4014  or  b2976 )"}, {"subsystem": "Transport, Extracellular", "name": "Malate transport via proton symport (2 H)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"mal__L_c": 1.0, "h_e": -2.0, "mal__L_e": -1.0, "h_c": 2.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "MALt2_2", "gene_reaction_rule": "b3528"}, {"subsystem": "Citric Acid Cycle", "name": "malate dehydrogenase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"mal__L_c": -1.0, "nadh_c": 1.0, "nad_c": -1.0, "oaa_c": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "MDH", "gene_reaction_rule": "b3236"}, {"subsystem": "Anaplerotic reactions", "name": "malic enzyme (NAD)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"nad_c": -1.0, "mal__L_c": -1.0, "co2_c": 1.0, "pyr_c": 1.0, "nadh_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ME1", "gene_reaction_rule": "b1479"}, {"subsystem": "Anaplerotic reactions", "name": "malic enzyme (NADP)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pyr_c": 1.0, "mal__L_c": -1.0, "co2_c": 1.0, "nadph_c": 1.0, "nadp_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "ME2", "gene_reaction_rule": "b2463"}, {"subsystem": "Oxidative Phosphorylation", "name": "NADH dehydrogenase (ubiquinone-8 & 3 protons)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"q8h2_c": 1.0, "h_e": 3.0, "h_c": -4.0, "nad_c": 1.0, "nadh_c": -1.0, "q8_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "NADH16", "gene_reaction_rule": "(b2276 and b2277 and b2278 and b2279 and b2280 and b2281 and b2282 and b2283 and b2284 and b2285 and b2286 and b2287 and b2288)"}, {"subsystem": "Oxidative Phosphorylation", "name": "NAD transhydrogenase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"nadh_c": 1.0, "nadph_c": -1.0, "nadp_c": 1.0, "nad_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "NADTRHD", "gene_reaction_rule": "(b3962 or (b1602 and b1603))"}, {"subsystem": "Inorganic Ion Transport and Metabolism", "name": "ammonia reversible transport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"nh4_e": -1.0, "nh4_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "NH4t", "gene_reaction_rule": "(s0001 or b0451)"}, {"subsystem": "Transport, Extracellular", "name": "o2 transport via diffusion", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"o2_c": 1.0, "o2_e": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "O2t", "gene_reaction_rule": "s0001"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "pyruvate dehydrogenase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"nadh_c": 1.0, "accoa_c": 1.0, "pyr_c": -1.0, "coa_c": -1.0, "nad_c": -1.0, "co2_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PDH", "gene_reaction_rule": "( b0114  and  b0115  and  b0116 )"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "phosphofructokinase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h_c": 1.0, "atp_c": -1.0, "fdp_c": 1.0, "adp_c": 1.0, "f6p_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PFK", "gene_reaction_rule": "( b3916  or  b1723 )"}, {"subsystem": "Pyruvate Metabolism", "name": "pyruvate formate lyase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pyr_c": -1.0, "coa_c": -1.0, "accoa_c": 1.0, "for_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PFL", "gene_reaction_rule": "(((b0902 and b0903) and b2579) or (b0902 and b0903) or (b0902 and b3114) or (b3951 and b3952))"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "glucose-6-phosphate isomerase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"g6p_c": -1.0, "f6p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PGI", "gene_reaction_rule": "b4025"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "phosphoglycerate kinase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"atp_c": -1.0, "13dpg_c": 1.0, "adp_c": 1.0, "3pg_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PGK", "gene_reaction_rule": "b2926"}, {"subsystem": "Pentose Phosphate Pathway", "name": "6-phosphogluconolactonase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"6pgc_c": 1.0, "h2o_c": -1.0, "6pgl_c": -1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PGL", "gene_reaction_rule": "b0767"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "phosphoglycerate mutase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"2pg_c": -1.0, "3pg_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PGM", "gene_reaction_rule": "(b3612 or b4395 or b0755)"}, {"subsystem": "Inorganic Ion Transport and Metabolism", "name": "phosphate reversible transport via proton symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"pi_e": -1.0, "h_e": -1.0, "pi_c": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PIt2r", "gene_reaction_rule": "(b2987 or b3493)"}, {"subsystem": "Anaplerotic reactions", "name": "phosphoenolpyruvate carboxylase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "co2_c": -1.0, "pep_c": -1.0, "h_c": 1.0, "oaa_c": 1.0, "pi_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PPC", "gene_reaction_rule": "b3956"}, {"subsystem": "Anaplerotic reactions", "name": "phosphoenolpyruvate carboxykinase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pep_c": 1.0, "co2_c": 1.0, "adp_c": 1.0, "oaa_c": -1.0, "atp_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PPCK", "gene_reaction_rule": "b3403"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "phosphoenolpyruvate synthase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"h2o_c": -1.0, "atp_c": -1.0, "pyr_c": -1.0, "pep_c": 1.0, "amp_c": 1.0, "pi_c": 1.0, "h_c": 2.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PPS", "gene_reaction_rule": "b1702"}, {"subsystem": "Pyruvate Metabolism", "name": "phosphotransacetylase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"actp_c": 1.0, "pi_c": -1.0, "coa_c": 1.0, "accoa_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PTAr", "gene_reaction_rule": "(b2297 or b2458)"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "pyruvate kinase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"pep_c": -1.0, "pyr_c": 1.0, "h_c": -1.0, "adp_c": -1.0, "atp_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PYK", "gene_reaction_rule": "(b1854 or b1676)"}, {"subsystem": "Transport, Extracellular", "name": "pyruvate reversible transport via proton symport", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"pyr_c": 1.0, "h_e": -1.0, "pyr_e": -1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "PYRt2r", "gene_reaction_rule": ""}, {"subsystem": "Pentose Phosphate Pathway", "name": "ribulose 5-phosphate 3-epimerase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"xu5p__D_c": 1.0, "ru5p__D_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "RPE", "gene_reaction_rule": "(b3386 or b4301)"}, {"subsystem": "Pentose Phosphate Pathway", "name": "ribose-5-phosphate isomerase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"r5p_c": -1.0, "ru5p__D_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "RPI", "gene_reaction_rule": "( b2914  or  b4090 )"}, {"subsystem": "Transport, Extracellular", "name": "succinate transport via proton symport (2 H)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"succ_c": 1.0, "h_e": -2.0, "succ_e": -1.0, "h_c": 2.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "SUCCt2_2", "gene_reaction_rule": "b3528"}, {"subsystem": "Transport, Extracellular", "name": "succinate transport out via proton antiport", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"succ_c": -1.0, "h_e": -1.0, "succ_e": 1.0, "h_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "SUCCt3", "gene_reaction_rule": ""}, {"subsystem": "Oxidative Phosphorylation", "name": "succinate dehydrogenase (irreversible)", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"q8h2_c": 1.0, "succ_c": -1.0, "fum_c": 1.0, "q8_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "SUCDi", "gene_reaction_rule": "(b0721 and b0722 and b0723 and b0724)"}, {"subsystem": "Citric Acid Cycle", "name": "succinyl-CoA synthetase (ADP-forming)", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"atp_c": -1.0, "succoa_c": 1.0, "succ_c": -1.0, "coa_c": -1.0, "adp_c": 1.0, "pi_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "SUCOAS", "gene_reaction_rule": "( b0728  and  b0729 )"}, {"subsystem": "Pentose Phosphate Pathway", "name": "transaldolase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"e4p_c": 1.0, "g3p_c": -1.0, "s7p_c": -1.0, "f6p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "TALA", "gene_reaction_rule": "(b2464 or b0008)"}, {"subsystem": "Oxidative Phosphorylation", "name": "NAD(P) transhydrogenase", "upper_bound": 1000.0, "lower_bound": 0.0, "notes": {}, "metabolites": {"nadp_c": -1.0, "nadph_c": 1.0, "h_e": -2.0, "h_c": 2.0, "nad_c": 1.0, "nadh_c": -1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "THD2", "gene_reaction_rule": "( b1602  and  b1603 )"}, {"subsystem": "Pentose Phosphate Pathway", "name": "transketolase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"r5p_c": -1.0, "xu5p__D_c": -1.0, "g3p_c": 1.0, "s7p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "TKT1", "gene_reaction_rule": "( b2935  or  b2465 )"}, {"subsystem": "Pentose Phosphate Pathway", "name": "transketolase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"e4p_c": -1.0, "xu5p__D_c": -1.0, "g3p_c": 1.0, "f6p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "TKT2", "gene_reaction_rule": "( b2935  or  b2465 )"}, {"subsystem": "Glycolysis/Gluconeogenesis", "name": "triose-phosphate isomerase", "upper_bound": 1000.0, "lower_bound": -1000.0, "notes": {}, "metabolites": {"dhap_c": -1.0, "g3p_c": 1.0}, "objective_coefficient": 0.0, "variable_kind": "continuous", "id": "TPI", "gene_reaction_rule": "b3919"}], "description": "Ecoli_core_model", "notes": {}, "genes": [{"name": "b1241", "id": "b1241"}, {"name": "b0351", "id": "b0351"}, {"name": "s0001", "id": "s0001"}, {"name": "b3115", "id": "b3115"}, {"name": "b2296", "id": "b2296"}, {"name": "b1849", "id": "b1849"}, {"name": "b1276", "id": "b1276"}, {"name": "b0118", "id": "b0118"}, {"name": "b0474", "id": "b0474"}, {"name": "b0726", "id": "b0726"}, {"name": "b0116", "id": "b0116"}, {"name": "b0727", "id": "b0727"}, {"name": "b2587", "id": "b2587"}, {"name": "b0356", "id": "b0356"}, {"name": "b1478", "id": "b1478"}, {"name": "b3739", "id": "b3739"}, {"name": "b3731", "id": "b3731"}, {"name": "b3736", "id": "b3736"}, {"name": "b3737", "id": "b3737"}, {"name": "b3738", "id": "b3738"}, {"name": "b3735", "id": "b3735"}, {"name": "b3732", "id": "b3732"}, {"name": "b3733", "id": "b3733"}, {"name": "b3734", "id": "b3734"}, {"name": "b0720", "id": "b0720"}, {"name": "b0733", "id": "b0733"}, {"name": "b0978", "id": "b0978"}, {"name": "b0734", "id": "b0734"}, {"name": "b0979", "id": "b0979"}, {"name": "b2975", "id": "b2975"}, {"name": "b3603", "id": "b3603"}, {"name": "b2779", "id": "b2779"}, {"name": "b2925", "id": "b2925"}, {"name": "b2097", "id": "b2097"}, {"name": "b1773", "id": "b1773"}, {"name": "b4232", "id": "b4232"}, {"name": "b3925", "id": "b3925"}, {"name": "b2492", "id": "b2492"}, {"name": "b0904", "id": "b0904"}, {"name": "b4151", "id": "b4151"}, {"name": "b4152", "id": "b4152"}, {"name": "b4154", "id": "b4154"}, {"name": "b4153", "id": "b4153"}, {"name": "b2416", "id": "b2416"}, {"name": "b1819", "id": "b1819"}, {"name": "b1817", "id": "b1817"}, {"name": "b1818", "id": "b1818"}, {"name": "b2415", "id": "b2415"}, {"name": "b4122", "id": "b4122"}, {"name": "b1611", "id": "b1611"}, {"name": "b1612", "id": "b1612"}, {"name": "b3528", "id": "b3528"}, {"name": "b1852", "id": "b1852"}, {"name": "b1779", "id": "b1779"}, {"name": "b1621", "id": "b1621"}, {"name": "b1101", "id": "b1101"}, {"name": "b2417", "id": "b2417"}, {"name": "b1297", "id": "b1297"}, {"name": "b3870", "id": "b3870"}, {"name": "b0811", "id": "b0811"}, {"name": "b0810", "id": "b0810"}, {"name": "b0809", "id": "b0809"}, {"name": "b1761", "id": "b1761"}, {"name": "b0485", "id": "b0485"}, {"name": "b1812", "id": "b1812"}, {"name": "b1524", "id": "b1524"}, {"name": "b3213", "id": "b3213"}, {"name": "b3212", "id": "b3212"}, {"name": "b4077", "id": "b4077"}, {"name": "b2029", "id": "b2029"}, {"name": "b0875", "id": "b0875"}, {"name": "b1136", "id": "b1136"}, {"name": "b4015", "id": "b4015"}, {"name": "b2133", "id": "b2133"}, {"name": "b1380", "id": "b1380"}, {"name": "b4014", "id": "b4014"}, {"name": "b2976", "id": "b2976"}, {"name": "b3236", "id": "b3236"}, {"name": "b1479", "id": "b1479"}, {"name": "b2463", "id": "b2463"}, {"name": "b2280", "id": "b2280"}, {"name": "b2288", "id": "b2288"}, {"name": "b2282", "id": "b2282"}, {"name": "b2276", "id": "b2276"}, {"name": "b2278", "id": "b2278"}, {"name": "b2286", "id": "b2286"}, {"name": "b2277", "id": "b2277"}, {"name": "b2279", "id": "b2279"}, {"name": "b2285", "id": "b2285"}, {"name": "b2281", "id": "b2281"}, {"name": "b2284", "id": "b2284"}, {"name": "b2283", "id": "b2283"}, {"name": "b2287", "id": "b2287"}, {"name": "b3962", "id": "b3962"}, {"name": "b1603", "id": "b1603"}, {"name": "b1602", "id": "b1602"}, {"name": "b0451", "id": "b0451"}, {"name": "b0114", "id": "b0114"}, {"name": "b0115", "id": "b0115"}, {"name": "b3916", "id": "b3916"}, {"name": "b1723", "id": "b1723"}, {"name": "b3951", "id": "b3951"}, {"name": "b2579", "id": "b2579"}, {"name": "b3952", "id": "b3952"}, {"name": "b0903", "id": "b0903"}, {"name": "b0902", "id": "b0902"}, {"name": "b3114", "id": "b3114"}, {"name": "b4025", "id": "b4025"}, {"name": "b2926", "id": "b2926"}, {"name": "b0767", "id": "b0767"}, {"name": "b4395", "id": "b4395"}, {"name": "b3612", "id": "b3612"}, {"name": "b0755", "id": "b0755"}, {"name": "b3493", "id": "b3493"}, {"name": "b2987", "id": "b2987"}, {"name": "b3956", "id": "b3956"}, {"name": "b3403", "id": "b3403"}, {"name": "b1702", "id": "b1702"}, {"name": "b2458", "id": "b2458"}, {"name": "b2297", "id": "b2297"}, {"name": "b1676", "id": "b1676"}, {"name": "b1854", "id": "b1854"}, {"name": "b4301", "id": "b4301"}, {"name": "b3386", "id": "b3386"}, {"name": "b2914", "id": "b2914"}, {"name": "b4090", "id": "b4090"}, {"name": "b0722", "id": "b0722"}, {"name": "b0721", "id": "b0721"}, {"name": "b0724", "id": "b0724"}, {"name": "b0723", "id": "b0723"}, {"name": "b0728", "id": "b0728"}, {"name": "b0729", "id": "b0729"}, {"name": "b2464", "id": "b2464"}, {"name": "b0008", "id": "b0008"}, {"name": "b2935", "id": "b2935"}, {"name": "b2465", "id": "b2465"}, {"name": "b3919", "id": "b3919"}], "metabolites": [{"name": "H", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H", "compartment": "c", "id": "h_c"}, {"name": "Nicotinamide-adenine-dinucleotide", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C21H26N7O14P2", "compartment": "c", "id": "nad_c"}, {"name": "Coenzyme-A", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C21H32N7O16P3S", "compartment": "c", "id": "coa_c"}, {"name": "Acetaldehyde", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H4O", "compartment": "c", "id": "acald_c"}, {"name": "Nicotinamide-adenine-dinucleotide-reduced", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C21H27N7O14P2", "compartment": "c", "id": "nadh_c"}, {"name": "Acetyl-CoA", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C23H34N7O17P3S", "compartment": "c", "id": "accoa_c"}, {"name": "Acetaldehyde", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H4O", "compartment": "e", "id": "acald_e"}, {"name": "Acetyl-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H3O5P", "compartment": "c", "id": "actp_c"}, {"name": "ADP", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C10H12N5O10P2", "compartment": "c", "id": "adp_c"}, {"name": "Acetate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H3O2", "compartment": "c", "id": "ac_c"}, {"name": "ATP", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C10H12N5O13P3", "compartment": "c", "id": "atp_c"}, {"name": "Citrate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H5O7", "compartment": "c", "id": "cit_c"}, {"name": "cis-Aconitate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H3O6", "compartment": "c", "id": "acon_C_c"}, {"name": "H2O", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H2O", "compartment": "c", "id": "h2o_c"}, {"name": "Isocitrate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H5O7", "compartment": "c", "id": "icit_c"}, {"name": "H", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H", "compartment": "e", "id": "h_e"}, {"name": "Acetate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H3O2", "compartment": "e", "id": "ac_e"}, {"name": "AMP", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C10H12N5O7P", "compartment": "c", "id": "amp_c"}, {"name": "2-Oxoglutarate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H4O5", "compartment": "c", "id": "akg_c"}, {"name": "CO2", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "CO2", "compartment": "c", "id": "co2_c"}, {"name": "Succinyl-CoA", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C25H35N7O19P3S", "compartment": "c", "id": "succoa_c"}, {"name": "2-Oxoglutarate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H4O5", "compartment": "e", "id": "akg_e"}, {"name": "Ethanol", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H6O", "compartment": "c", "id": "etoh_c"}, {"name": "Phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "HO4P", "compartment": "c", "id": "pi_c"}, {"name": "D-Fructose-6-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H11O9P", "compartment": "c", "id": "f6p_c"}, {"name": "Nicotinamide-adenine-dinucleotide-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C21H25N7O17P3", "compartment": "c", "id": "nadp_c"}, {"name": "3-Phospho-D-glycerate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H4O7P", "compartment": "c", "id": "3pg_c"}, {"name": "Glyceraldehyde-3-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H5O6P", "compartment": "c", "id": "g3p_c"}, {"name": "D-Glucose-6-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H11O9P", "compartment": "c", "id": "g6p_c"}, {"name": "Phosphoenolpyruvate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H2O6P", "compartment": "c", "id": "pep_c"}, {"name": "L-Glutamine", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H10N2O3", "compartment": "c", "id": "gln__L_c"}, {"name": "L-Glutamate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H8NO4", "compartment": "c", "id": "glu__L_c"}, {"name": "alpha-D-Ribose-5-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H9O8P", "compartment": "c", "id": "r5p_c"}, {"name": "D-Erythrose-4-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H7O7P", "compartment": "c", "id": "e4p_c"}, {"name": "Nicotinamide-adenine-dinucleotide-phosphate-reduced", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C21H26N7O17P3", "compartment": "c", "id": "nadph_c"}, {"name": "Oxaloacetate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H2O5", "compartment": "c", "id": "oaa_c"}, {"name": "Pyruvate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H3O3", "compartment": "c", "id": "pyr_c"}, {"name": "CO2", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "CO2", "compartment": "e", "id": "co2_e"}, {"name": "Ubiquinone-8", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C49H74O4", "compartment": "c", "id": "q8_c"}, {"name": "Ubiquinol-8", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C49H76O4", "compartment": "c", "id": "q8h2_c"}, {"name": "O2", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "O2", "compartment": "c", "id": "o2_c"}, {"name": "D-Lactate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H5O3", "compartment": "c", "id": "lac__D_c"}, {"name": "D-Lactate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H5O3", "compartment": "e", "id": "lac__D_e"}, {"name": "D-Glycerate-2-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H4O7P", "compartment": "c", "id": "2pg_c"}, {"name": "Ethanol", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H6O", "compartment": "e", "id": "etoh_e"}, {"name": "Formate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "CH1O2", "compartment": "e", "id": "for_e"}, {"name": "D-Fructose", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H12O6", "compartment": "e", "id": "fru_e"}, {"name": "Fumarate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H2O4", "compartment": "e", "id": "fum_e"}, {"name": "D-Glucose", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H12O6", "compartment": "e", "id": "glc__D_e"}, {"name": "L-Glutamine", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H10N2O3", "compartment": "e", "id": "gln__L_e"}, {"name": "L-Glutamate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H8NO4", "compartment": "e", "id": "glu__L_e"}, {"name": "H2O", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H2O", "compartment": "e", "id": "h2o_e"}, {"name": "L-Malate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H4O5", "compartment": "e", "id": "mal__L_e"}, {"name": "Ammonium", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H4N", "compartment": "e", "id": "nh4_e"}, {"name": "O2", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "O2", "compartment": "e", "id": "o2_e"}, {"name": "Phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "HO4P", "compartment": "e", "id": "pi_e"}, {"name": "Pyruvate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H3O3", "compartment": "e", "id": "pyr_e"}, {"name": "Succinate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H4O4", "compartment": "e", "id": "succ_e"}, {"name": "Dihydroxyacetone-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H5O6P", "compartment": "c", "id": "dhap_c"}, {"name": "D-Fructose-1-6-bisphosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H10O12P2", "compartment": "c", "id": "fdp_c"}, {"name": "Formate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "CH1O2", "compartment": "c", "id": "for_c"}, {"name": "Fumarate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H2O4", "compartment": "c", "id": "fum_c"}, {"name": "Succinate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H4O4", "compartment": "c", "id": "succ_c"}, {"name": "L-Malate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C4H4O5", "compartment": "c", "id": "mal__L_c"}, {"name": "6-phospho-D-glucono-1-5-lactone", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H9O9P", "compartment": "c", "id": "6pgl_c"}, {"name": "3-Phospho-D-glyceroyl-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C3H4O10P2", "compartment": "c", "id": "13dpg_c"}, {"name": "Ammonium", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "H4N", "compartment": "c", "id": "nh4_c"}, {"name": "6-Phospho-D-gluconate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C6H10O10P", "compartment": "c", "id": "6pgc_c"}, {"name": "D-Ribulose-5-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H9O8P", "compartment": "c", "id": "ru5p__D_c"}, {"name": "Glyoxylate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C2H1O3", "compartment": "c", "id": "glx_c"}, {"name": "D-Xylulose-5-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C5H9O8P", "compartment": "c", "id": "xu5p__D_c"}, {"name": "Sedoheptulose-7-phosphate", "notes": "{}", "annotation": "{}", "_constraint_sense": "E", "charge": "0", "_bound": "0.0", "formula": "C7H13O10P", "compartment": "c", "id": "s7p_c"}], "id": "Ecoli_core_model"};
}
